Two Sum LeetCode Solution in C++ Using Two Pointers: Optimized Approach Explained

Two Sum II - Input Array Is Sorted in C++


Problem Statement

Given a 1-indexed array of integers numbers that is already sorted in non-decreasing order, find two numbers such that they add up to a specific target number. Let these two numbers be numbers[index1] and numbers[index2] where 1 <= index1 < index2 <= numbers.length.

Return the indices of the two numbers, index1 and index2, added by one as an integer array [index1, index2] of length 2.

The tests are generated such that there is exactly one solution. You may not use the same element twice.

Your solution must use only constant extra space.


Examples


Example 1:

Input: numbers = [2,7,11,15], target = 9

Output: [1,2]

Explanation: The sum of 2 and 7 is 9. Therefore, index1 = 1, index2 = 2. We return [1, 2].


Example 2:

Input: numbers = [2,3,4], target = 6

Output: [1,3]

Explanation: The sum of 2 and 4 is 6. Therefore index1 = 1, index2 = 3. We return [1, 3].


Example 3:

Input: numbers = [-1,0], target = -1

Output: [1,2]

Explanation: The sum of -1 and 0 is -1. Therefore index1 = 1, index2 = 2. We return [1, 2].


Constraints and Considerations

  • 2 <= numbers.length <= 3 * 104
  • -1000 <= numbers[i] <= 1000
  • numbers is sorted in non-decreasing order.
  • -1000 <= target <= 1000
  • The tests are generated such that there is exactly one solution.

Approach

We will use two pointers approach to solve this problem.In this approach we create two pointers first is pointing to the starting index of the array and second is pointing to the last index of the array.

Condition 1: if we add the elements of the first pointer and second pointer and their sum is equal to the target value return the answer.

Condition 2: if we add the elements of the first pointer and second pointer and their sum is less than the target value just increment the first pointer.

Condition 3: if we add the elements of the first pointer and second pointer and their sum is greater than the target value just decrement
the second pointer.

Code

#include<iostream>
#include<vector>
using namespace std;

int main(int argc, char const *argv[])
{
    int numbers[4]={2,7,11,15},target=9;
    int i=0,j=3;
    while(i<j){
        if(numbers[i]+numbers[j]==target){
            cout<<i<<" "<<j;
            break;
        }
        else if(numbers[i]+numbers[j]<target){
            i++;
        }
        else if(numbers[i]+numbers[j]>target){
            j--;
        }
    }
    return 0;
}


  • Time Complexity:- O(n)
  • Space Complexity:- O(n)

Try implementing this solution yourself and share your thoughts in the comments! For more coding interview solutions, check out our other algorithm guides.

Comments